<script setup>
import * as inputEnums from '@/app/enums/input';

import Select from '@/app/components/inputs/Select.vue';
</script>

<script>
export default {
    props: {
        value: {
            type: Array,
            default: [],
        },
    },
    data() {
        return {
            items: [],
        };
    },
    created() {
        this.booted.helpers.http.send(this, {
            method: 'GET',
            path: 'product/product/' + this.$route.params.product_id,
            query: {
                'with[0]': 'category.specifications.options',
            },
        }).then((response) => {
            if (response.statusType === 'success') {
                response.json().then((body) => {
                    let specifications = body.category.specifications;

                    for (let specificationKey in specifications) {
                        let specification = specifications[specificationKey],
                            options = {},
                            value;

                        for (let optionKey in specification.options) {
                            let option = specification.options[optionKey];
                            options[option.id] = option.name[this.booted.locale];

                            if (this.value.includes(option.id)) {
                                value = option.id;
                            }
                        }

                        this.items[specificationKey] = {
                            name: 'options',
                            value: value,
                            label: specification.name[this.booted.locale],
                            options: {
                                items: options,
                                isMultiple: true,
                            },
                            wrapperSize: inputEnums.wrapperSizes.lg,
                        };
                    }
                });
            }
        });
    },
};
</script>

<template>
    <template v-for="item in items">
        <Select :name="item.name"
                :value="item.value"
                :label="item.label"
                :options="item.options"
                :wrapperSize="item.wrapperSize" />
    </template>
</template>
